import React from 'react';

import UserActions from '../actions/UserActions';
import UserStore from '../stores/UserStore';

import Footer from './Footer';
import Navbar from './Navbar';

export default class App extends React.Component {
    constructor(props) {
        super(props);

        this.state = UserStore.getState();

        this.onChange = this.onChange.bind(this);
    }

    onChange(state) {
        this.setState(state);
    }

    componentDidMount() {
        UserStore.listen(this.onChange);
        UserActions.loginUser();
    }

    componentWillUnmount() {
        UserStore.unlisten(this.onChange);
    }

    render() {
        return (
            <div>
                <Navbar />
                {this.props.children}
                <Footer />
            </div>
        );
    }
}